/***********************************************************************************************************************
 *
 * BlueBook - use live code examples in your book
 * Copyright (C) 2011-2011 by Tidalwave s.a.s.
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebook.java.net
 * SCM: https://hg.java.net/hg/bluebook~src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebook.plugin.maven;

import javax.annotation.Nonnull;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;
import it.tidalwave.bluebook.filter.java.JavaFilter;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class ProgramListingTemplate
  {    
    public void process (final @Nonnull JavaFilter filter, final @Nonnull Reader r, final @Nonnull Writer w)
      throws IOException
      {
        w.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
        w.write("<programlisting version=\"5.0\"\n");
        w.write("                language=\"java\"\n");
        w.write("                xmlns=\"http://docbook.org/ns/docbook\"\n");
        w.write("                xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n");
        w.write("                xmlns:xi=\"http://www.w3.org/2001/XInclude\"\n");
        w.write("                xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n");
        w.write("                xsi:schemaLocation=\"http://docbook.org/ns/docbook http://www.docbook.org/xml/5.0/xsd/docbook.xsd\n");
        w.write("                http://www.w3.org/2001/XInclude http://www.w3.org/2001/XInclude.xsd\n");
        w.write("                http://www.w3.org/1999/xlink http://www.docbook.org/xml/5.0/xsd/xlink.xsd\">");
        w.write("<![CDATA[");

        filter.filter(r, w);

        w.write("]]>");
        w.write("</programlisting>\n");
      }
    
  }
